//
//  Category.m
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 03/05/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "Category.h"
#import "Track.h"


@implementation Category
@dynamic name;
@dynamic updated;
@dynamic tracks;

- (void)addTracksObject:(Track *)value {    
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    [self willChangeValueForKey:@"tracks" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    [[self primitiveValueForKey:@"tracks"] addObject:value];
    [self didChangeValueForKey:@"tracks" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    [changedObjects release];
}

- (void)removeTracksObject:(Track *)value {
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    [self willChangeValueForKey:@"tracks" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    [[self primitiveValueForKey:@"tracks"] removeObject:value];
    [self didChangeValueForKey:@"tracks" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    [changedObjects release];
}

- (void)addTracks:(NSSet *)value {    
    [self willChangeValueForKey:@"tracks" withSetMutation:NSKeyValueUnionSetMutation usingObjects:value];
    [[self primitiveValueForKey:@"tracks"] unionSet:value];
    [self didChangeValueForKey:@"tracks" withSetMutation:NSKeyValueUnionSetMutation usingObjects:value];
}

- (void)removeTracks:(NSSet *)value {
    [self willChangeValueForKey:@"tracks" withSetMutation:NSKeyValueMinusSetMutation usingObjects:value];
    [[self primitiveValueForKey:@"tracks"] minusSet:value];
    [self didChangeValueForKey:@"tracks" withSetMutation:NSKeyValueMinusSetMutation usingObjects:value];
}

- (void)setUpdatedTimestamp
{
    [self setUpdated:[NSDate date]];
}

- (NSDictionary *)toDictionary
{
    NSMutableDictionary *dictionary = [[NSMutableDictionary alloc] init];
    [dictionary setObject:[[[self objectID] URIRepresentation] absoluteString] forKey:@"id"];
    [dictionary setObject:[self name] forKey:@"name"];
    [dictionary setObject:[[self updated] description] forKey:@"updated"];
    return dictionary;
}

- (NSString *)encodeJSON
{
    return [[self toDictionary] JSONRepresentation];
}
@end
