//
//  CorreAppDelegate.m
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 10/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "CorreAppDelegate.h"
#import "SettingsViewController.h"

#define kUpdatedDateKey @"UpdateDate"
#define kUserNameKey @"UserName"
#define kNicknameKey @"Nickname"
#define kPasswordKey @"Password"
#define kPlacemarksKey @"Placemarks"
#define kMarksDistanceKey @"MarksDistance"
#define kAccuracyKey @"Accuracy"
#define kLastCategorySelected @"LastCategorySelected"
#define kDataToSync @"dataToSync"

@implementation CorreAppDelegate


@synthesize window=_window;

@synthesize tabBarController=_tabBarController;

@synthesize managedObjectModel;
@synthesize managedObjectContext;
@synthesize persistentStoreCoordinator;
@synthesize tracking;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
    // Add the tab bar controller's current view as a subview of the window
    
    // Comprovem estan definides les preferències, si no les definim per defecte.
    NSDate *updateDate = (NSDate *)[[NSUserDefaults standardUserDefaults] objectForKey:kUpdatedDateKey];
    if (updateDate == nil) {
        NSURL *filesKMLPath = [NSURL fileURLWithPath:[[self applicationDocumentsDirectory] stringByAppendingPathComponent:@"KMLFiles"]];
        [[NSFileManager defaultManager] createDirectoryAtPath:[filesKMLPath path] withIntermediateDirectories:NO attributes:nil error:nil];
        
        [[NSUserDefaults standardUserDefaults] setObject:[NSDate date] forKey:kUpdatedDateKey];
        [[NSUserDefaults standardUserDefaults] setObject:@"" forKey:kNicknameKey];
        [[NSUserDefaults standardUserDefaults] setObject:@"" forKey:kPasswordKey];
        [[NSUserDefaults standardUserDefaults] setBool:YES forKey:kPlacemarksKey];
        [[NSUserDefaults standardUserDefaults] setInteger:1000 forKey:kMarksDistanceKey];
        [[NSUserDefaults standardUserDefaults] setInteger:5 forKey:kAccuracyKey];
        [[NSUserDefaults standardUserDefaults] setObject:@"" forKey:kLastCategorySelected];
        [[NSUserDefaults standardUserDefaults] setBool:NO forKey:kDataToSync];
        
        [[NSUserDefaults standardUserDefaults] synchronize];
        
        NSManagedObject *firstCategory = [NSEntityDescription insertNewObjectForEntityForName:@"Category" inManagedObjectContext:self.managedObjectContext];
        [firstCategory setValue:NSLocalizedString(@"Walk", @"Walk") forKey:@"name"];
        [firstCategory setValue:[NSDate date] forKey:@"updated"];
        NSManagedObject *secondCategory = [NSEntityDescription insertNewObjectForEntityForName:@"Category" inManagedObjectContext:self.managedObjectContext];
        [secondCategory setValue:NSLocalizedString(@"Run", @"Run") forKey:@"name"];
        [secondCategory setValue:[NSDate date] forKey:@"updated"];
        NSManagedObject *thirdCategory = [NSEntityDescription insertNewObjectForEntityForName:@"Category" inManagedObjectContext:self.managedObjectContext];
        [thirdCategory setValue:NSLocalizedString(@"Cycling", @"Cycling") forKey:@"name"];
        [thirdCategory setValue:[NSDate date] forKey:@"updated"];
        NSManagedObject *fourthCategory = [NSEntityDescription insertNewObjectForEntityForName:@"Category" inManagedObjectContext:self.managedObjectContext];
        [fourthCategory setValue:NSLocalizedString(@"Hiking", @"Hiking") forKey:@"name"];
        [fourthCategory setValue:[NSDate date] forKey:@"updated"];
        [managedObjectContext save:nil];
        
        [(SyncManager *)[SyncManager sharedSyncManager] registerSyncTaskType:SyncTaskCreate forManagedObject:firstCategory];
        [(SyncManager *)[SyncManager sharedSyncManager] registerSyncTaskType:SyncTaskCreate forManagedObject:secondCategory];
        [(SyncManager *)[SyncManager sharedSyncManager] registerSyncTaskType:SyncTaskCreate forManagedObject:thirdCategory];
        [(SyncManager *)[SyncManager sharedSyncManager] registerSyncTaskType:SyncTaskCreate forManagedObject:fourthCategory];
        
        [[NSUserDefaults standardUserDefaults] setObject:[[[secondCategory objectID] URIRepresentation] absoluteString] forKey:kLastCategorySelected];
        [[NSUserDefaults standardUserDefaults] synchronize];
        NSLog(@"Last Category Selected: %@", [[NSUserDefaults standardUserDefaults] objectForKey:kLastCategorySelected]);
    }
    [[NSUserDefaults standardUserDefaults] setValue:[NSDate date] forKey:kUpdatedDateKey];
    
    // Iniciem locationManager
    NSLog(@"Iniciem localitzacio");
    [(TrackLocationManager *)[TrackLocationManager sharedTrackLocationManager] wakeUpLocationManager];
    
    [self setTracking:NO];
        
    self.window.rootViewController = self.tabBarController;
    [self.window makeKeyAndVisible];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
    NSLog(@"Passem a background...");
    if (![self tracking]) {
        NSLog(@"cridem shutDownLocationManager");
        [(TrackLocationManager *)[TrackLocationManager sharedTrackLocationManager] shutDownLocationManager];
    }
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
    NSLog(@"Tornem a ser actius");
    if ([(TrackLocationManager *)[TrackLocationManager sharedTrackLocationManager] locationManager] == nil) {
        [(TrackLocationManager *)[TrackLocationManager sharedTrackLocationManager] wakeUpLocationManager];
    }
    
    [self.window makeKeyAndVisible];
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}

- (void)dealloc
{
    [managedObjectContext release];
    [persistentStoreCoordinator release];
    [managedObjectModel release];
    [_window release];
    [_tabBarController release];
    [super dealloc];
}


// Optional UITabBarControllerDelegate method.
- (void)tabBarController:(UITabBarController *)tabBarController didSelectViewController:(UIViewController *)viewController
{

}


/*
// Optional UITabBarControllerDelegate method.
- (void)tabBarController:(UITabBarController *)tabBarController didEndCustomizingViewControllers:(NSArray *)viewControllers changed:(BOOL)changed
{
}
*/

#pragma mark Core Data stack

/**
 Returns the managed object context for the application.
 If the context doesn't already exist, it is created and bound to the persistent store coordinator for the application.
 */
- (NSManagedObjectContext *) managedObjectContext {
	
    if (managedObjectContext != nil) {
        return managedObjectContext;
    }
	
    NSPersistentStoreCoordinator *coordinator = [self persistentStoreCoordinator];
    if (coordinator != nil) {
        managedObjectContext = [[NSManagedObjectContext alloc] init];
        
        NSUndoManager *undoManager = [[NSUndoManager alloc] init];
        [managedObjectContext setUndoManager:undoManager];
        [undoManager release];
        
        [managedObjectContext setPersistentStoreCoordinator: coordinator];
    }
    return managedObjectContext;
}


/**
 Returns the managed object model for the application.
 If the model doesn't already exist, it is created by merging all of the models found in the application bundle.
 */
- (NSManagedObjectModel *)managedObjectModel {
	
    if (managedObjectModel != nil) {
        return managedObjectModel;
    }
    managedObjectModel = [[NSManagedObjectModel mergedModelFromBundles:nil] retain];    
    return managedObjectModel;
}


/**
 Returns the persistent store coordinator for the application.
 If the coordinator doesn't already exist, it is created and the application's store added to it.
 */
- (NSPersistentStoreCoordinator *)persistentStoreCoordinator {
	
    if (persistentStoreCoordinator != nil) {
        return persistentStoreCoordinator;
    }
	
    NSURL *storeUrl = [NSURL fileURLWithPath: [[self applicationDocumentsDirectory] stringByAppendingPathComponent: @"Corre.sqlite"]];
	
	NSError *error = nil;
    persistentStoreCoordinator = [[NSPersistentStoreCoordinator alloc] initWithManagedObjectModel:[self managedObjectModel]];
    if (![persistentStoreCoordinator addPersistentStoreWithType:NSSQLiteStoreType configuration:nil URL:storeUrl options:nil error:&error]) {
		/*
		 Replace this implementation with code to handle the error appropriately.
		 
		 abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development. If it is not possible to recover from the error, display an alert panel that instructs the user to quit the application by pressing the Home button.
		 
		 Typical reasons for an error here include:
		 * The persistent store is not accessible
		 * The schema for the persistent store is incompatible with current managed object model
		 Check the error message to determine what the actual problem was.
		 */
		NSLog(@"Unresolved error %@, %@", error, [error userInfo]);
		abort();
    }    
	
    return persistentStoreCoordinator;
}


#pragma mark -
#pragma mark Application's Documents directory

/**
 Returns the path to the application's Documents directory.
 */
- (NSString *)applicationDocumentsDirectory {
	return [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject];
}


@end
