//
//  DetailTrackViewController.h
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 27/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MapKit/MapKit.h>
#import "Track.h"
#import "Place.h"
#import "PlaceMark.h"
#import "MapPlacemark.h"
#import "MapRoute.h"
#import "MapRouteView.h"
#import "EditTrackViewController.h"

@interface DetailTrackViewController : UIViewController <MKMapViewDelegate, UIScrollViewDelegate, UITableViewDelegate, EditTrackViewProtocol> {
    Track *theTrack;
    
    IBOutlet UILabel *dateLabel;
    IBOutlet UILabel *distanceLabel;
    IBOutlet UILabel *timeLabel;
    IBOutlet UILabel *paceLabel;
    IBOutlet UILabel *speedLabel;
    IBOutlet UILabel *ppmLabel;
    IBOutlet UILabel *categoryLabel;
    IBOutlet UILabel *maxSpeedLabel;
    IBOutlet UILabel *minAltitudeLabel;
    IBOutlet UILabel *maxAltitudeLabel;
    IBOutlet UITextView *noteTextView;
    
    IBOutlet MKMapView *map;
    UIScrollView *scrollView;
    UIScrollView *horizontalScroll;
    IBOutlet UIView *trackStats;
    IBOutlet UITableView *splitStats;
    UIPageControl *pageControl;
    MapRoute *route;
    MapRouteView *routeOverlay;
    
    BOOL hasPlacemarks;    
}

@property (nonatomic, retain) Track *theTrack;

@property (nonatomic, retain) UILabel *dateLabel;
@property (nonatomic, retain) UILabel *distanceLabel;
@property (nonatomic, retain) UILabel *timeLabel;
@property (nonatomic, retain) UILabel *paceLabel;
@property (nonatomic, retain) UILabel *speedLabel;
@property (nonatomic, retain) UILabel *ppmLabel;
@property (nonatomic, retain) UILabel *categoryLabel;
@property (nonatomic, retain) UILabel *maxSpeedLabel;
@property (nonatomic, retain) UILabel *minAltitudeLabel;
@property (nonatomic, retain) UILabel *maxAltitudeLabel;
@property (nonatomic, retain) UITextView *noteTextView;

@property (nonatomic, retain) MKMapView *map;
@property (nonatomic, retain) UIScrollView *scrollView;
@property (nonatomic, retain) UIScrollView *horizontalScroll;
@property (nonatomic, retain) UIView *trackStats;
@property (nonatomic, retain) UITableView *splitStats;
@property (nonatomic, retain) UIPageControl *pageControl;

@property (readonly) BOOL hasPlacemarks;

- (void)setTrackViews;
- (IBAction)showEditTrackView;

- (NSString *)formatTimeInterval:(NSTimeInterval) theInterval;

- (IBAction)manageMapView:(UISegmentedControl *)sender;
- (NSMutableArray *)getPlacemarks;
- (MKCoordinateRegion)getTrackCoordinateRegion;

- (IBAction)pageControlChanged:(UIPageControl *)sender;

@end
