//
//  DetailTrackViewController.m
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 27/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "DetailTrackViewController.h"


@implementation DetailTrackViewController

@synthesize theTrack, dateLabel, distanceLabel, timeLabel, paceLabel, speedLabel, ppmLabel, categoryLabel, maxSpeedLabel, minAltitudeLabel, maxAltitudeLabel, noteTextView, map, trackStats, splitStats;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [theTrack release];
    [dateLabel release];
    [distanceLabel release];
    [timeLabel release];
    [paceLabel release];
    [speedLabel release];
    [maxSpeedLabel release];
    [minAltitudeLabel release];
    [maxAltitudeLabel release];
    [map release];
    [scrollView release];
    [trackStats release];
    [splitStats release];
    [horizontalScroll release];
    [pageControl release];
    [ppmLabel release];
    [categoryLabel release];
    [noteTextView release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    [[self navigationItem] setTitle:[theTrack name]];
    [[self navigationItem] setRightBarButtonItem:[[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemEdit target:self action:@selector(showEditTrackView)] animated:YES];

    [self setTrackViews];
    
    [map addAnnotations:[self getPlacemarks]];
    [map setRegion:[self getTrackCoordinateRegion]];
    if (!route) {
        NSArray *thePlaces = [[theTrack places] sortedArrayUsingDescriptors:[NSArray arrayWithObject:[[[NSSortDescriptor alloc] initWithKey:@"time" ascending:YES] autorelease]]];
        route = [[MapRoute alloc] initWithCenterCoordinate:[self getTrackCoordinateRegion].center places:thePlaces];
    }
    [map addOverlay:route];
}

- (void)viewDidUnload
{
    [dateLabel release];
    dateLabel = nil;
    [distanceLabel release];
    distanceLabel = nil;
    [timeLabel release];
    timeLabel = nil;
    [paceLabel release];
    paceLabel = nil;
    [speedLabel release];
    speedLabel = nil;
    [maxSpeedLabel release];
    maxSpeedLabel = nil;
    [minAltitudeLabel release];
    minAltitudeLabel = nil;
    [maxAltitudeLabel release];
    maxAltitudeLabel = nil;
    [map release];
    map = nil;
    [scrollView release];
    scrollView = nil;
    [trackStats release];
    trackStats = nil;
    [splitStats release];
    splitStats = nil;
    [horizontalScroll release];
    horizontalScroll = nil;
    [pageControl release];
    pageControl = nil;
    [ppmLabel release];
    ppmLabel = nil;
    [categoryLabel release];
    categoryLabel = nil;
    [noteTextView release];
    noteTextView = nil;
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Getters and setters

- (BOOL)hasPlacemarks
{
    return [[theTrack placemarks] count] > 1;
}

- (void)setHorizontalScroll:(UIScrollView *)aHorizontalScroll
{
    self.horizontalScroll = aHorizontalScroll;
}

- (UIScrollView *)horizontalScroll
{
    if (horizontalScroll == nil) {
        horizontalScroll = [[UIScrollView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, 340)];
        [horizontalScroll setPagingEnabled:YES];
        [horizontalScroll setDirectionalLockEnabled:YES];
        [horizontalScroll setBounces:NO];
        [horizontalScroll setShowsHorizontalScrollIndicator:NO];
        [horizontalScroll setShowsVerticalScrollIndicator:NO];
        [horizontalScroll setDelegate:self];
    }
    
    return horizontalScroll;
}

- (void)setScrollView:(UIScrollView *)aScrollView
{
    self.scrollView = aScrollView;
}

- (UIScrollView *)scrollView
{
    if (scrollView == nil) {
        CGFloat scrollViewHeight = [self hasPlacemarks] ? 340 : 372;
        scrollView = [[UIScrollView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, scrollViewHeight)];
        [scrollView addSubview:trackStats];
        [scrollView setContentSize:CGSizeMake(trackStats.frame.size.width, trackStats.frame.size.height)];
    }
    
    return scrollView;
}

- (void)setPageControl:(UIPageControl *)aPageControl
{
    self.pageControl = aPageControl;
}

- (UIPageControl *)pageControl
{
    if (pageControl == nil) {
        pageControl = [[UIPageControl alloc] initWithFrame:CGRectMake(0, 340, self.view.frame.size.width, self.view.frame.size.height - 384)];
        [pageControl setNumberOfPages:2];
        [pageControl setCurrentPage:0];
        [pageControl addTarget:self action:@selector(pageControlChanged:) forControlEvents:UIControlEventValueChanged];
    }
    
    return pageControl;
}

#pragma mark - Track view

- (void)setTrackViews
{
    // Inicialització de les dades
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setLocale:[NSLocale currentLocale]];
    [dateFormatter setDateStyle:NSDateFormatterShortStyle];
    [dateFormatter setTimeStyle:NSDateFormatterShortStyle];
    dateLabel.text = [dateFormatter stringFromDate:[theTrack date]];
    [dateFormatter release];
    distanceLabel.text = [NSString localizedStringWithFormat:@"%.2f km", [theTrack distanceInKm]];
    timeLabel.text = [theTrack formatTime];
    paceLabel.text = [NSString localizedStringWithFormat:@"%@ m/km", [theTrack paceString]];
    speedLabel.text = [NSString localizedStringWithFormat:@"%.2f km/h", [theTrack speedInKmH]];
    if ([[theTrack ppm] intValue] > 0) {
        [ppmLabel setHidden:NO];
        ppmLabel.text = [NSString stringWithFormat:@"%i ppm", [[theTrack ppm] intValue]];
    }
    categoryLabel.text = [[theTrack category] name];
    maxSpeedLabel.text = [NSString localizedStringWithFormat:@"%.2f km/h", [theTrack maxSpeedInKmH]];
    minAltitudeLabel.text = [NSString localizedStringWithFormat:@"%.2f m", [[theTrack minAltitude] floatValue]];
    maxAltitudeLabel.text = [NSString localizedStringWithFormat:@"%.2f m", [[theTrack maxAltitude] floatValue]];
    if ([theTrack note] && [[theTrack note] length] > 0 ) {
        [[trackStats viewWithTag:10] setHidden:NO];
        [trackStats setFrame:CGRectMake(0, 0, trackStats.frame.size.width, trackStats.frame.size.height + 50 + noteTextView.frame.size.height)];
        noteTextView.text = [theTrack note];
        [noteTextView setHidden:NO];
    }
    
    // Si hi ha marques s'inicialitza horizontalScroll per mostrar les dades de les marques
    NSLog(@"Hay marcas: %@", [self hasPlacemarks] ? @"Sí" : @"No");
    if ([self hasPlacemarks]) {
        [self.horizontalScroll setContentSize:CGSizeMake(self.view.frame.size.width*2, 340)];
        [splitStats setFrame:CGRectMake(self.view.frame.size.width, 0, self.view.frame.size.width, 340)];
        [horizontalScroll addSubview:self.scrollView];
        [horizontalScroll addSubview:splitStats];
        [[self view] addSubview:horizontalScroll];
        [[self view] addSubview:self.pageControl];
    } else {
        [[self view] addSubview:self.scrollView];
    }
}

- (IBAction)showEditTrackView
{
    EditTrackViewController *editTrackViewController = [[EditTrackViewController alloc] initEditWithTrack:theTrack delegate:self];
    [self presentModalViewController:editTrackViewController animated:YES];
}

- (void)editTrackViewDidEndEditing:(EditTrackViewController *)editTrackViewController
{
    [[self navigationItem] setTitle:[theTrack name]];
    categoryLabel.text = [[theTrack category] name];
    if ([[theTrack ppm] intValue] > 0) {
        [ppmLabel setHidden:NO];
        ppmLabel.text = [NSString stringWithFormat:@"%i ppm", [[theTrack ppm] intValue]];
    } else {
        [ppmLabel setHidden:YES];
    }
    if ([theTrack note] && [[theTrack note] length] > 0) {
        [[trackStats viewWithTag:10] setHidden:NO];
        CGFloat heightToResize = noteTextView.hidden ? 50 + noteTextView.frame.size.height : 0;
        [trackStats setFrame:CGRectMake(0, 0, trackStats.frame.size.width, trackStats.frame.size.height + heightToResize)];
        noteTextView.text = [theTrack note];
        [noteTextView setHidden:NO];
        [scrollView setContentSize:CGSizeMake(trackStats.frame.size.width, trackStats.frame.size.height)];
    } else if (!noteTextView.hidden){
        [trackStats setFrame:CGRectMake(0, 0, trackStats.frame.size.width, trackStats.frame.size.height - 50 - noteTextView.frame.size.height)];
        [[trackStats viewWithTag:10] setHidden:YES];
        [noteTextView setHidden:YES];
        [scrollView setContentSize:CGSizeMake(trackStats.frame.size.width, trackStats.frame.size.height)];
    }
//    noteLabel.text = [theTrack note];
}

#pragma mark - Map view methods

- (IBAction)manageMapView:(UISegmentedControl *)sender
{
    NSLog(@"manageMapView - selectedSegmentIndex: %i", [sender selectedSegmentIndex]);
    if ([sender selectedSegmentIndex] == 0) {
        NSLog(@"manageMapView - Inside if");
        [map removeFromSuperview];
    } else if ([sender selectedSegmentIndex] == 1) {
        NSLog(@"manageMapView - Inside else if");
        [[self view] insertSubview:self.map atIndex:20];
        [routeOverlay setNeedsDisplayInMapRect:[route boundingMapRect]];
    }
}

- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id<MKAnnotation>)annotation
{
    MKPinAnnotationView *aPin;
    if ([(MapPlacemark *) annotation placemarkType] == MapPlacemarkTypeStart) {
        aPin = [[MKPinAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:@"StartPin"];
        [aPin setPinColor:MKPinAnnotationColorGreen];
    } else if ([(MapPlacemark *) annotation placemarkType] == MapPlacemarkTypeEnd) {
        aPin = [[MKPinAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:@"EndPin"];
        [aPin setPinColor:MKPinAnnotationColorRed];
    } else {
        aPin = (MKPinAnnotationView *)[mapView dequeueReusableAnnotationViewWithIdentifier:@"SplitPin"];
        if (aPin == nil) {
            aPin = [[MKPinAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:@"SplitPin"];
        }
        [aPin setAnnotation:annotation];
        [aPin setPinColor:MKPinAnnotationColorPurple];
    }
    [aPin setCanShowCallout:YES];
    
    return aPin;
}

- (MKOverlayView *)mapView:(MKMapView *)mapView viewForOverlay:(id<MKOverlay>)overlay
{
    if (!routeOverlay) {
        routeOverlay = [[MapRouteView alloc] initWithOverlay:overlay];        
    }
    
    return routeOverlay;
}

- (NSMutableArray *)getPlacemarks
{
    NSArray *places = [[theTrack places] sortedArrayUsingDescriptors:[NSArray arrayWithObject:[[[NSSortDescriptor alloc] initWithKey:@"time" ascending:YES] autorelease]]];
    NSMutableArray *mapPlacemarks = [[[NSMutableArray alloc] init] autorelease];
    [mapPlacemarks addObject:[[[MapPlacemark alloc] 
                               initWithCoordinates:(Place *)[places objectAtIndex:0] 
                               placeName:NSLocalizedString(@"Start", @"Start") 
                               description:nil
                               type:MapPlacemarkTypeStart] autorelease]];
    [mapPlacemarks addObject:[[[MapPlacemark alloc] 
                               initWithCoordinates:(Place *)[places lastObject] 
                               placeName:NSLocalizedString(@"End",@"End")
                               description:[NSString localizedStringWithFormat:@"%@ - %.2fkm - %@m/km", [
                                            theTrack formatTime], [theTrack distanceInKm], [theTrack paceString]] 
                               type:MapPlacemarkTypeEnd] autorelease]];
    if ([self hasPlacemarks]) {
        NSArray *placemarks = [[theTrack placemarks] sortedArrayUsingDescriptors:[NSArray arrayWithObject:[[[NSSortDescriptor alloc] initWithKey:@"startTime" ascending:YES] autorelease]]];
        
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setLocale:[NSLocale currentLocale]];
        NSLog(@"Placemarks to show: %i", [placemarks count] - 1);
        for (NSInteger i = 0; i < [placemarks count]-1; i++) {
            NSLog(@"Placemark %i: %@", i, [[[placemarks objectAtIndex:i] startTime]description]);
            Placemark *aPlacemark = (Placemark *)[placemarks objectAtIndex:i];
            [mapPlacemarks addObject:[[[MapPlacemark alloc] 
                                       initWithCoordinates:(Place *)[aPlacemark place] 
                                       placeName:[NSString localizedStringWithFormat:@"%i - %@", i+1, [aPlacemark name]]
                                       description:[NSString localizedStringWithFormat:@"%@ - %.2fm - %@m/km", [aPlacemark formatTime], [[aPlacemark distance] floatValue], [aPlacemark paceString]]
                                       type:MapPlacemarkTypeSplit] autorelease]];
        }
        [dateFormatter release];
    }

    return mapPlacemarks;
}

- (MKCoordinateRegion)getTrackCoordinateRegion
{
    NSArray *orderedPlaces  = [[theTrack places] sortedArrayUsingDescriptors:[NSArray arrayWithObject:[[[NSSortDescriptor alloc] initWithKey:@"time" ascending:YES] autorelease]]];
    float minLatitude = 91;
    float maxLatitude = -91;
    float minLongitude = 181;
    float maxLongitude = -181;
    for (NSInteger i = 0; i < [orderedPlaces count]; i++) {
        minLatitude = MIN(minLatitude, [[[orderedPlaces objectAtIndex:i] latitude] floatValue]);
        maxLatitude = MAX(maxLatitude, [[[orderedPlaces objectAtIndex:i] latitude] floatValue]);
        minLongitude = MIN(minLongitude, [[[orderedPlaces objectAtIndex:i] longitude] floatValue]);
        maxLongitude = MAX(maxLongitude, [[[orderedPlaces objectAtIndex:i] longitude] floatValue]);
    }
    
    NSLog(@"MKCoordinateRegion: Coordinate(%f, %f) - Span(%f, %f))", (minLatitude + maxLatitude)/2, (minLongitude + maxLongitude)/2, (maxLatitude - minLatitude)*1.20, (maxLongitude - minLongitude)*1.20);
    return MKCoordinateRegionMake(CLLocationCoordinate2DMake(((minLatitude + maxLatitude)/2), ((minLongitude + maxLongitude)/2)), MKCoordinateSpanMake((maxLatitude - minLatitude)*1.20, (maxLongitude - minLongitude)*1.20));
    
}

#pragma mark - Table view delegate methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return [[theTrack placemarks] count];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 6;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSString *cellIdentifier = (indexPath.row == 0) ? @"NameCellIdentifier" : @"DataCellIdentifier";
    UITableViewCellStyle cellStyle = (indexPath.row == 0) ? UITableViewCellStyleValue1 : UITableViewCellStyleValue2;
    
    NSArray *sortedPlacemarks = [[theTrack placemarks] sortedArrayUsingDescriptors:[NSArray arrayWithObject:[[[NSSortDescriptor alloc] initWithKey:@"startTime" ascending:YES] autorelease]]];
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:cellStyle reuseIdentifier:cellIdentifier] autorelease];
        [cell setAccessoryType:UITableViewCellAccessoryNone];
        if (indexPath.row == 0) {
            [cell setSelectionStyle:UITableViewCellSelectionStyleBlue];
        } else {
            [cell setSelectionStyle:UITableViewCellSelectionStyleNone];
        }
    }
    
    switch (indexPath.row) {
        case 0:
            [[cell textLabel] setText:[[sortedPlacemarks objectAtIndex:indexPath.section] name]];
            [[cell detailTextLabel] setText:[NSString stringWithFormat:@"%i", indexPath.section + 1]];
            break;
        case 1:
            [[cell textLabel] setText:NSLocalizedString(@"Time", @"Time")];
            [[cell detailTextLabel] setText:[[sortedPlacemarks objectAtIndex:indexPath.section] formatTime]];
            break;
        case 2:
            [[cell textLabel] setText:NSLocalizedString(@"Distance", @"Distance")];
            [[cell detailTextLabel] setText:[NSString localizedStringWithFormat:@"%.2f m", [[[sortedPlacemarks objectAtIndex:indexPath.section] distance] floatValue]]];
            break;
        case 3:
            [[cell textLabel] setText:NSLocalizedString(@"Pace", @"Pace")];
            [[cell detailTextLabel] setText:[NSString localizedStringWithFormat:@"%@ m/km", [[sortedPlacemarks objectAtIndex:indexPath.section] paceString]]];
            break;
        case 4:
            [[cell textLabel] setText:NSLocalizedString(@"Speed", @"Speed")];
            [[cell detailTextLabel] setText:[NSString localizedStringWithFormat:@"%.2f km/h", [[sortedPlacemarks objectAtIndex:indexPath.section] speedInKmH]]];
            break;
        case 5:
            [[cell textLabel] setText:NSLocalizedString(@"Max Speed", @"Max Speed")];
            [[cell detailTextLabel] setText:[NSString localizedStringWithFormat:@"%.2f km/h", [[sortedPlacemarks objectAtIndex:indexPath.section] maxSpeedInKmH]]];
            break;
        default:
            [[cell textLabel] setText:@"Unknown"];
            break;
    }
    
    return cell;
}

#pragma mark - Horizontal ScrollView methods

- (void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    if (((NSInteger)horizontalScroll.bounds.origin.x % (NSInteger)self.view.frame.size.width) == 0) {
        pageControl.currentPage = (NSInteger) (horizontalScroll.bounds.origin.x / self.view.frame.size.width);
        [[[self navigationItem] rightBarButtonItem] setEnabled:((horizontalScroll.bounds.origin.x / self.view.frame.size.width) == 0) ? YES : NO];
    }
}

- (IBAction)pageControlChanged:(UIPageControl *)sender
{
    [horizontalScroll scrollRectToVisible:CGRectMake(horizontalScroll.frame.size.width * sender.currentPage, 0, horizontalScroll.frame.size.width, horizontalScroll.frame.size.height) animated:YES];
}

- (NSString*)formatTimeInterval:(NSTimeInterval) theInterval
{
    int hours = 0;
    int minutes = 0;
    int seconds = 0;
    if (theInterval >= 60*60) {
        hours = round(theInterval / 60*60);
    }
    if (theInterval - hours*60*60 >= 60) {
        minutes = floor((theInterval - hours * 60 * 60) / 60);
    }
    seconds = floor(theInterval - hours*60*60 - minutes*60);
    NSString *result;
    if (hours == 0) {
        result = [NSString stringWithFormat:@"%02i:%02i", minutes, seconds];
    } else {
        result = [NSString stringWithFormat:@"%i:%02i:%02i", hours, minutes, seconds];
    }        
    return result;
}

@end
