//
//  EditTrackViewController.h
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 02/05/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreData/CoreData.h>
#import "CorreAppDelegate.h"
#import "EditTrackViewProtocol.h"
#import "SelectCategoryTableViewProtocol.h"
#import "SelectCategoryTableViewController.h"
#import "Track.h"

@interface EditTrackViewController : UIViewController <UITextFieldDelegate, SelectCategoryTableViewProtocol> {
    id <EditTrackViewProtocol> delegate;
    
    IBOutlet UIScrollView *scrollView;
    IBOutlet UITextField *nameTextField;
    IBOutlet UITextField *ppmTextField;
    IBOutlet UITextField *noteTextView;
    IBOutlet UILabel *categoryLabel;
    UIView *activeField;
    CGFloat scrollViewContentsHeight;
    
    NSManagedObjectContext *managedObjectContext;
    Track *theTrack;
    
}

@property (nonatomic, retain) id <EditTrackViewProtocol> delegate;

@property (nonatomic, retain) UIScrollView *scrollView;
@property (nonatomic, retain) UITextField *nameTextField;
@property (nonatomic, retain) UITextField *ppmTextField;
@property (nonatomic, retain) UITextField *noteTextView;
@property (nonatomic, retain) UILabel *categoryLabel;
@property (nonatomic, retain) UIView *activeField;
@property CGFloat scrolViewContentsHeight;

@property (nonatomic, retain) Track *theTrack;
@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;

- (id)initEditWithTrack:(Track *)aTrack delegate:(id<EditTrackViewProtocol>)aDelegate;

- (IBAction)save;
- (IBAction)cancel;
- (IBAction)done:(id)sender;
- (IBAction)showSelectCategoryTable:(id)sender;

- (BOOL)validate;

- (void)registerKeyboardNotifications;
- (void)keyboardWasShown:(NSNotification *)aNotification;
- (void)keyboardWillBeHidden:(NSNotification *)aNotification;



@end
