//
//  MapPlacemarks.h
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 28/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <MapKit/MapKit.h>
#import "Place.h"

enum MapPlacemarkType {
    MapPlacemarkTypeStart = 0,
    MapPlacemarkTypeEnd = 1,
    MapPlacemarkTypeSplit = 2
    };
typedef NSUInteger MapPlacemarkType;

@interface MapPlacemark : NSObject <MKAnnotation> {
    CLLocationCoordinate2D coordinate;
    NSString *title;
    NSString *subtitle;
    MapPlacemarkType placemarkType;
}

@property (nonatomic) CLLocationCoordinate2D coordinate;
@property (nonatomic, retain) NSString *title;
@property (nonatomic, retain) NSString *subtitle;
@property (nonatomic) MapPlacemarkType placemarkType;

- (id)initWithCoordinates:(Place *)aPlace placeName:(NSString *)aPlaceName description:(NSString *)aDescription type:(MapPlacemarkType)aType;

@end
