//
//  MapRoute.m
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 29/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "MapRoute.h"


@implementation MapRoute

@synthesize points, pointsCount;

- (id)initWithCenterCoordinate:(CLLocationCoordinate2D)aCoordinate places:(NSArray *)thePlaces
{
    self = [super init];
    if (self) {
        coordinate = aCoordinate;
        // Initialize points
        float minX = CGFLOAT_MAX;
        float maxX = CGFLOAT_MIN;
        float minY = CGFLOAT_MAX;
        float maxY = CGFLOAT_MIN;
        pointsCount = [thePlaces count];
        points = malloc(sizeof(MKMapPoint)*pointsCount);
        for (NSInteger i = 0; i < [thePlaces count]; i++) {
            points[i] = MKMapPointForCoordinate(CLLocationCoordinate2DMake([[(Place *)[thePlaces objectAtIndex:i] latitude] floatValue], [[(Place *)[thePlaces objectAtIndex:i] longitude] floatValue]));
            minX = MIN(points[i].x, minX);
            maxX = MAX(points[i].x, maxX);
            minY = MIN(points[i].y, minY);
            maxY = MAX(points[i].y, maxY);            
        }
        boundingMapRect = MKMapRectMake(minX, minY, maxX - minX, maxY - minY);
    }
    
    return self;
}

- (void)dealloc
{
    free(points);
    [super dealloc];
}

- (CLLocationCoordinate2D)coordinate
{
    return coordinate;
}

- (MKMapRect)boundingMapRect
{
    return boundingMapRect;
}

@end
