//
//  MapRouteView.m
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 30/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "MapRouteView.h"


@implementation MapRouteView

@synthesize path;

- (void)createPath
{
    MapRoute *mapRoute = (MapRoute *)[self overlay];
    
    CGMutablePathRef newPath = NULL;
    newPath = CGPathCreateMutable();
    CGPoint point = [self pointForMapPoint:mapRoute.points[0]];
    CGPathMoveToPoint(newPath, NULL, point.x, point.y);
    for (NSInteger i = 1; i < mapRoute.pointsCount; i++) {
        point = [self pointForMapPoint:mapRoute.points[i]];
        CGPathAddLineToPoint(newPath, NULL, point.x, point.y);
    }
    
    path = newPath;
}

- (void)applyStrokePropertiesToContext:(CGContextRef)context atZoomScale:(MKZoomScale)zoomScale
{
    CGContextSetRGBStrokeColor(context, 0.0, 0.0, 1.0, 0.5);
    CGContextSetLineWidth(context, MKRoadWidthAtZoomScale(zoomScale));
    CGContextSetLineCap(context, kCGLineCapRound);
    CGContextSetLineJoin(context, kCGLineJoinRound);
}

- (void)strokePath:(CGPathRef)aPath inContext:(CGContextRef)context
{
    CGContextAddPath(context, aPath);
    CGContextStrokePath(context);
}

- (void)drawMapRect:(MKMapRect)mapRect zoomScale:(MKZoomScale)zoomScale inContext:(CGContextRef)context
{
    [self createPath];
    [self applyStrokePropertiesToContext:context atZoomScale:zoomScale];
    [self strokePath:path inContext:context];
}

@end
