//
//  NewTrackViewController.h
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 24/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreLocation/CoreLocation.h>
#import "CorreAppDelegate.h"
#import "TrackLocationManager.h"
#import "EditTrackViewProtocol.h"
#import "EditTrackViewController.h"
#import "Track.h"
#import "Placemark.h"
#import "Place.h"
#import "SyncManager.h"

@interface NewTrackViewController : UIViewController <CLLocationManagerDelegate, EditTrackViewProtocol, TrackLocationManagerProtocol> {
    // Elements de la interfície
    IBOutlet UILabel *totalTimeLabel;
    IBOutlet UILabel *intervalTimeLabel;
    IBOutlet UIButton *startButton;
    IBOutlet UIButton *stopButton;
    
    NSManagedObjectContext *managedObjectContext;
    TrackLocationManager *sharedTrackLocationManager;
    
    BOOL tracking;                          // Indica si s'està enregistrant o no
    NSTimer *timer;                         // Temporitzador per implementar el cronòmetre
    
    Track *track;
    Placemark *currentPlacemark;
}

@property (nonatomic, retain) UILabel *totalTimeLabel;
@property (nonatomic, retain) UILabel *intervalTimeLabel;
@property (nonatomic, retain) UIButton *startButton;
@property (nonatomic, retain) UIButton *stopButton;

@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;
@property (nonatomic, retain) TrackLocationManager *sharedTrackLocationManager;

@property (nonatomic) BOOL tracking;
@property (nonatomic, retain) NSTimer *timer;
@property (nonatomic, retain) NSMutableDictionary *pauseTimes;

@property (nonatomic, retain) Track *track;
@property (nonatomic, retain) Placemark *currentPlacemark;

- (IBAction)startTracking:(id) sender;
- (IBAction)stopTracking:(id) sender;
- (void)updateTimer;

// Location helpers
- (void)updateTrackValuesWithNewLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation place:(Place *)aPlace;
- (void)updateIntervalValuesWithNewLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation place:(Place *)aPlace;

// Helpers
- (NSString *)formatTimeInterval:(NSTimeInterval) theInterval;

- (void)logRecords;


@end
