//
//  Placemark.m
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 03/05/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "Placemark.h"
#import "Place.h"
#import "Track.h"


@implementation Placemark
@dynamic time;
@dynamic name;
@dynamic minAltitude;
@dynamic maxSpeed;
@dynamic distance;
@dynamic type;
@dynamic maxAltitude;
@dynamic startTime;
@dynamic track;
@dynamic place;

- (float)speedInKmH
{
    return ([[self distance] floatValue]/ 1000) / ([[self time] floatValue] / 3600);
}

- (float)maxSpeedInKmH
{
    return ([[self maxSpeed] floatValue] * 3.6);
}

- (float)pace
{
    return ([[self distance] floatValue] == 0.0) ? 0.0 : ([[self time] floatValue] / 60) / ([[self distance] floatValue] / 1000);
}

- (NSString *)paceString
{
    NSInteger min = (NSInteger)[self pace];
    NSInteger sec = (NSInteger)(([self pace] - min) * 60);
    return [NSString stringWithFormat:@"%i:%02i", min, sec];
}

- (NSString*)formatTime
{
    NSTimeInterval theInterval = [[self time] floatValue];
    int hours = 0;
    int minutes = 0;
    int seconds = 0;
    if (theInterval >= 60*60) {
        hours = round(theInterval / 60*60);
    }
    if (theInterval - hours*60*60 >= 60) {
        minutes = floor((theInterval - hours * 60 * 60) / 60);
    }
    seconds = floor(theInterval - hours*60*60 - minutes*60);
    NSString *result;
    if (hours == 0) {
        result = [NSString stringWithFormat:@"%02i:%02i", minutes, seconds];
    } else {
        result = [NSString stringWithFormat:@"%i:%02i:%02i", hours, minutes, seconds];
    }        
    return result;
}

- (NSDictionary *)toDictionary
{
    NSMutableDictionary* objectDictionary = [[NSMutableDictionary alloc] init];
    [objectDictionary setObject:[[[self objectID] URIRepresentation] absoluteString] forKey:@"id"];
    [objectDictionary setObject:[self name] forKey:@"name"];
    [objectDictionary setObject:[[self startTime] description] forKey:@"startTime"];
    [objectDictionary setObject:[self time] forKey:@"time"];
    [objectDictionary setObject:[self minAltitude] forKey:@"minAltitude"];
    [objectDictionary setObject:[self maxAltitude] forKey:@"maxAltitude"];
    [objectDictionary setObject:[self maxSpeed] forKey:@"maxSpeed"];
    [objectDictionary setObject:[self distance] forKey:@"distance"];
    [objectDictionary setObject:[self minAltitude] forKey:@"minAltitude"];
    return objectDictionary;
}

- (NSString *)encodeJSON
{
    return [[self toDictionary] JSONRepresentation];
}

@end
