//
//  SelectCategoryTableViewController.m
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 02/05/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "SelectCategoryTableViewController.h"


@implementation SelectCategoryTableViewController

@synthesize delegate, managedObjectContext, theTrack, defaultRow, tableData;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (id)initWithTrack:(Track *)aTrack delegate:(id<SelectCategoryTableViewProtocol>)aDelegate
{
    self = [super initWithStyle:UITableViewStyleGrouped];
    if (self) {
        self.theTrack = aTrack;
        self.delegate = aDelegate;
        NSString *theToolbarTitle = NSLocalizedString(@"Categories", @"Categories");
        UIFont *theToolbarTitleFont = [UIFont boldSystemFontOfSize:20.0];
        UIToolbar *theToolbar = [[[UIToolbar alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, 44)] autorelease];
        [theToolbar setBarStyle:UIBarStyleBlackOpaque];
        CGSize labelSize = [theToolbarTitle sizeWithFont:theToolbarTitleFont];
        UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, labelSize.width, labelSize.height)];
        label.textAlignment = UITextAlignmentCenter;
        label.backgroundColor = [UIColor clearColor];
        label.shadowColor = [UIColor colorWithRed:229/255 green:231/266 blue:235/255 alpha:1.0];
        label.shadowOffset = CGSizeMake(0, 1);
        label.textColor = [UIColor whiteColor];
        label.text = theToolbarTitle;
        label.font = theToolbarTitleFont;
        NSArray *toolbarItems = [NSArray arrayWithObjects:
                                 [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil],
                                 [[UIBarButtonItem alloc] initWithCustomView:label],
                                 [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil],
                                 [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemCancel target:self action:@selector(dismissView)],nil];
        [theToolbar setItems:toolbarItems];
        [[self tableView] setTableHeaderView:theToolbar];
        NSLog(@"Subviews. %@", [[[self view] subviews] description]);
        [[self view] setBackgroundColor:[UIColor viewFlipsideBackgroundColor]];
    }
    
    return self;
}

- (void)dealloc
{
    [managedObjectContext release];
    [theTrack release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];

    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
    
    self.managedObjectContext = [(CorreAppDelegate *)[[UIApplication sharedApplication] delegate] managedObjectContext];
    NSFetchRequest *fetchRequest = [[NSFetchRequest alloc]  init];
    [fetchRequest setSortDescriptors:[NSArray arrayWithObject:[[[NSSortDescriptor alloc] initWithKey:@"name" ascending:YES] autorelease]]];
    [fetchRequest setEntity:[NSEntityDescription entityForName:@"Category" inManagedObjectContext:self.managedObjectContext]];
    NSError *error;
    self.tableData = [[[self managedObjectContext] executeFetchRequest:fetchRequest error:&error] copy];
    if (error) {
        NSLog(@"ERROR - SelectCategoryTableViewController: Error fetching categories");
    }
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [tableData count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // Configure the cell...
    [[cell textLabel] setText:[(Category *)[tableData objectAtIndex:indexPath.row] name]];
    if ([theTrack category] == (Category *)[tableData objectAtIndex:indexPath.row]) {
        [cell setAccessoryType:UITableViewCellAccessoryCheckmark];
    }
    
    return cell;
}

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     [detailViewController release];
     */
    [theTrack setCategory:(Category *)[tableData objectAtIndex:indexPath.row]];
    [[NSUserDefaults standardUserDefaults] setObject:[[[[theTrack category] objectID] URIRepresentation] absoluteString] forKey:@"LastCategorySelected"];
    NSError *error;
    if (![[self managedObjectContext] save:&error]) {
        NSLog(@"ERROR SelectCategoryTableViewController: Couldn't assign category to track");
    }
    NSLog(@"Suporta el protocol? %@", [delegate respondsToSelector:@selector(selectCategoryTableViewControllerEndEditingWithCategoryName:)] ? @"Sí" : @"No");
    if ([delegate respondsToSelector:@selector(selectCategoryTableViewControllerEndEditingWithCategoryName:)]) {
        [delegate selectCategoryTableViewControllerEndEditingWithCategoryName:[[theTrack category] name]];
    }
    [self dismissModalViewControllerAnimated:YES];
}

- (void)dismissView
{
    [self dismissModalViewControllerAnimated:YES];
}

@end
