//
//  SettingsViewController.h
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 12/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreData/CoreData.h>
#import "CorreAppDelegate.h"
#import "SetupPickerViewController.h"
#import "SetupTableViewController.h"


@interface SettingsViewController : UITableViewController <SetupPickerViewControllerDelegate, UIAlertViewDelegate> {
    NSManagedObjectContext *managedObjectContext;
    
    IBOutlet UITextField *userNicknameTextField;
    IBOutlet UITextField *userPasswordTextField;
    
    UITableViewCell *categoriesCell;
    
    IBOutlet UISwitch *togglePlacemarksSwitch;
    
    SetupPickerViewController *setupDistanceMarks;
    SetupPickerViewController *setupAccuracy;
    SetupTableViewController *setupCategories;

    NSMutableArray *optionsDistanceMarks;
    NSMutableArray *optionsAccuracy;
        
    NSMutableArray *userSettings;
    NSMutableArray *registerSettings;
    
    NSUserDefaults *userDefaults;

}

@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;

@property (nonatomic, retain) UITextField *userNicknameTextField;
@property (nonatomic, retain) UITextField *userPasswordTextField;

@property (nonatomic, retain) UITableViewCell *categoriesCell;

@property (nonatomic, retain) UISwitch *togglePlacemarksSwitch;

@property (nonatomic, retain) SetupPickerViewController *setupDistanceMarks;
@property (nonatomic, retain) SetupPickerViewController *setupAccuracy;
@property (nonatomic, retain, readonly) SetupTableViewController *setupCategories;

@property (nonatomic, retain) NSMutableArray *optionsDistanceMarks;
@property (nonatomic, retain) NSMutableArray *optionsAccuracy;

@property (nonatomic, retain) NSMutableArray *userSettings;
@property (nonatomic, retain) NSMutableArray *registerSettings;

@property (nonatomic, retain) NSUserDefaults *userDefaults;

- (IBAction)hideKeyboard:(id) sender;
- (IBAction)didEndEditing:(id) sender;
- (IBAction)setPlaceMarksChanged:(id) sender;

- (NSMutableDictionary *)setInterfaceValuesWithOptions:(NSArray *)options helpText:(NSString *)aHelpText settingText:(NSString *)aSettingText returnKey:(NSString *)aReturnKey;
- (UITableViewCell *)newCellWithLabel:(NSString *)aLabel reuseIdentifier:(NSString *)aReuseIdentifier textField:(UITextField *)aTextField;
- (void)setupRegisterSettings;
- (NSInteger)searchRowForValue:(NSInteger)aValue inArray:(NSArray *)anArray;
- (void)setupOptions;

- (void)setupPickerViewController:(SetupPickerViewController *)setupPickerViewController didFinishSetupWithInfo:(NSDictionary *)setupInfo;

@end
