//
//  PickerViewController.h
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 16/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>

@class SetupPickerViewController;

// Protocol per recuperar les dades.
@protocol SetupPickerViewControllerDelegate <NSObject>

@optional

- (void)setupPickerViewController:(SetupPickerViewController *)setupPickerViewController didFinishSetupWithInfo:(NSDictionary *)setupInfo;

@end


@interface SetupPickerViewController : UIViewController <UIPickerViewDelegate, UIPickerViewDataSource> {
    id <SetupPickerViewControllerDelegate> delegate;
    
    IBOutlet UIPickerView *pickerView;
    IBOutlet UILabel *helpText;
    IBOutlet UILabel *settingText;
    
    NSInteger rowSelected;
    NSMutableDictionary *interfaceValues;
    NSMutableDictionary *optionSelected;
}

@property (nonatomic, retain) id <SetupPickerViewControllerDelegate> delegate;

@property (nonatomic, retain) UIPickerView *pickerView;
@property (nonatomic, retain) UILabel *helpText;
@property (nonatomic, retain) UILabel *settingText;

@property (nonatomic) NSInteger rowSelected;
@property (nonatomic, retain) NSMutableDictionary *interfaceValues;
@property (nonatomic, retain) NSMutableDictionary *optionSelected;

- (id)initWithInterfaceData:(NSDictionary *)interfaceData rowSelected:(NSInteger)aRow delegate:(id <SetupPickerViewControllerDelegate>)aDelegate;

- (IBAction)dismissModalViewControllerAnimated:(BOOL)animated;

@end
