//
//  PickerViewController.m
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 16/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "SetupPickerViewController.h"

#define kNumberOfSections 1
#define kRowsOfSection 1

@implementation SetupPickerViewController

@synthesize delegate;
@synthesize pickerView;
@synthesize helpText;
@synthesize settingText;
@synthesize rowSelected;
@synthesize interfaceValues;
@synthesize optionSelected;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [pickerView release];
    [helpText release];
    [settingText release];
    
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (id)initWithInterfaceData:(NSMutableDictionary *)interfaceData rowSelected:(NSInteger)aRow delegate:(id <SetupPickerViewControllerDelegate>)aDelegate
{
    self = [super init];
    if (self) {
        self.rowSelected = aRow;
        self.interfaceValues = interfaceData;
        self.delegate = aDelegate;
    }
    return self;
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    if (interfaceValues) {
        helpText.text = (NSString *)[interfaceValues objectForKey:@"helpText"];
        settingText.text = (NSString *)[interfaceValues objectForKey:@"settingText"];
    }
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [pickerView selectRow:rowSelected inComponent:0 animated:NO];
    
    if (optionSelected == nil) {
        optionSelected = [[NSMutableDictionary alloc] initWithObjectsAndKeys:[interfaceValues objectForKey:@"ReturnKey"], @"ReturnKey", nil, @"Value", nil];
    }
    
    [optionSelected setValue:[[interfaceValues objectForKey:@"Options"] objectAtIndex:rowSelected] forKey:@"Value"];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Picker view data source

- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView
{
    return 1;
}

- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component
{
    return [[interfaceValues objectForKey:@"Options"] count];
}

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component
{
    return [[[interfaceValues objectForKey:@"Options"] objectAtIndex:row] objectForKey:@"OptionName"];
}

#pragma mark - Picker view delegate

- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
   if (optionSelected == nil) {
        optionSelected = [[NSMutableDictionary alloc] initWithObjectsAndKeys:[interfaceValues objectForKey:@"ReturnKey"], @"ReturnKey", nil, @"Value", nil];
    }
    
    [optionSelected setValue:[[interfaceValues objectForKey:@"Options"] objectAtIndex:row] forKey:@"Value"];

}

#pragma mark - Actions

- (IBAction)dismissModalViewControllerAnimated:(BOOL)animated
{
    [super dismissModalViewControllerAnimated:animated];
}

- (IBAction)done:(id) sender
{
    if ([delegate respondsToSelector:@selector(setupPickerViewController:didFinishSetupWithInfo:)]) {
        [delegate setupPickerViewController:self didFinishSetupWithInfo:optionSelected];
    }
    
    [self dismissModalViewControllerAnimated:YES];
}

@end
