//
//  SetupTableViewController.m
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 18/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "SetupTableViewController.h"

#define kNumberOfSections 1


@implementation SetupTableViewController

@synthesize data;
@synthesize managedObjectContext;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [managedObjectContext release];
    [data release];
    
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.managedObjectContext = [(CorreAppDelegate *)[[UIApplication sharedApplication] delegate] managedObjectContext];
    self.navigationItem.rightBarButtonItem = [self editButtonItem];
    self.navigationItem.title = NSLocalizedString(@"Categories", @"Categories");
    [[self tableView] setAllowsSelection:NO];
    [[self tableView] setAllowsSelectionDuringEditing:YES];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    addTextViewController = nil;
    [addTextViewController release];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    NSArray *sortDescriptors = [NSArray arrayWithObject:[[[NSSortDescriptor alloc] initWithKey:@"name" ascending:YES] autorelease]];
    [request setSortDescriptors:sortDescriptors];
    NSEntityDescription *entity = [NSEntityDescription entityForName:@"Category" inManagedObjectContext:self.managedObjectContext];
    [request setEntity:entity];
    NSError *error;
    self.data = [[managedObjectContext executeFetchRequest:request error:&error] mutableCopy];
    [[self tableView] reloadData];
    [request release];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Getter

- (AddTextViewController *)addTextViewController
{
    if (addTextViewController == nil) {
        addTextViewController = [[AddTextViewController alloc] initWithNibName:@"AddTextView" bundle:nil];
        [addTextViewController setDelegate:self];
        [addTextViewController setPlaceholder:NSLocalizedString(@"Category", @"Category")];
    }
    
    return addTextViewController;
}

#pragma mark - Table delegate methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return kNumberOfSections;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [data count];
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
{
    return NSLocalizedString(@"Categories", @"Categories");
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
        if ([tableView isEditing] && indexPath.row == 0) {
            [cell setSelectionStyle:UITableViewCellSelectionStyleBlue];
        } else {
            [cell setSelectionStyle:UITableViewCellSelectionStyleNone];
        }
    }
    
    [[cell textLabel] setText:[[data objectAtIndex:indexPath.row] name]];
    
    return cell;
}

#pragma mark - Table delegate edit methods

- (void)setEditing:(BOOL)editing animated:(BOOL)animated
{    
    if (editing) {
        [[self navigationItem] setHidesBackButton:YES animated:YES];
        NSManagedObject *blankCategory = [NSEntityDescription insertNewObjectForEntityForName:@"Category" inManagedObjectContext:self.managedObjectContext];
        [blankCategory setValue:@"" forKey:@"name"];
        [data insertObject:blankCategory atIndex:0];
        [[self tableView] insertRowsAtIndexPaths:[NSArray arrayWithObject:[NSIndexPath indexPathForRow:0 inSection:0]] withRowAnimation:UITableViewCellEditingStyleInsert];
        NSLog(@"Estamos editando");
        
        
    } else {
        [[self navigationItem] setHidesBackButton:NO animated:YES];
        Category *blankCategory = [data objectAtIndex:0];
        [managedObjectContext deleteObject:blankCategory];
        [data removeObjectAtIndex:0];
        [[self tableView] deleteRowsAtIndexPaths:[NSArray arrayWithObject:[NSIndexPath indexPathForRow:0 inSection:0]] withRowAnimation:UITableViewCellEditingStyleDelete];
        [managedObjectContext save:nil];
        NSLog(@"Dejamos de editar");
    }
    
    [super setEditing:editing animated:animated];
}

- (UITableViewCellEditingStyle)tableView:(UITableView *)tableView editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (!block && indexPath.row == 0) {
        return UITableViewCellEditingStyleInsert;
    } else {
        return UITableViewCellEditingStyleDelete;
    }
}

- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        if ([data count] > 2) {
            Category *categoryToDelete = [data objectAtIndex:indexPath.row];
            if ([[categoryToDelete tracks] count] == 0) {
                [(SyncManager *)[SyncManager sharedSyncManager] registerSyncTaskType:SyncTaskDelete forManagedObject:categoryToDelete];
                [managedObjectContext deleteObject:categoryToDelete];
                [data removeObjectAtIndex:indexPath.row];
                [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationRight];
            } else {
                UIAlertView *alertDialog = [[UIAlertView alloc]
                                            initWithTitle:NSLocalizedString(@"Delete category", @"Delete category") 
                                            message:NSLocalizedString(@"There are tracks assigned to this category. It mustn't be any tracks assigned to delete the category.", @"There are tracks assigned to this category. It mustn't be any tracks assigned to delete the category.") 
                                            delegate:nil cancelButtonTitle:NSLocalizedString(@"OK", @"OK") 
                                            otherButtonTitles:nil];
                [alertDialog show];
            }
        } else {
            UIAlertView *alertDialog = [[UIAlertView alloc]
                                        initWithTitle:NSLocalizedString(@"Delete category", @"Delete category") 
                                        message:NSLocalizedString(@"There must be at least one category", @"There must be at least one category") 
                                        delegate:nil cancelButtonTitle:NSLocalizedString(@"OK", @"OK") 
                                        otherButtonTitles:nil];
            [alertDialog show];
            [alertDialog release];
        }
        
    } else if (editingStyle == UITableViewCellEditingStyleInsert) {
        NSLog(@"Ha seleccionado la crucecita");
        [self presentModalViewController:self.addTextViewController animated:YES];
    }
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.row == 0) {
        NSLog(@"ha seleccionado añadir");
        [self presentModalViewController:self.addTextViewController animated:YES];
    }
}

#pragma mark - AddTextView delegate

- (void)addTextViewController:(AddTextViewController *)addTextViewController didFinishSetupWithText:(NSString *)text
{
    NSLog(@"%@", text);
    NSFetchRequest *request = [[NSFetchRequest alloc] init];
    NSPredicate *predicate = [NSPredicate predicateWithFormat:@"name = %@", text];
    [request setPredicate:predicate];
    NSEntityDescription *entity = [NSEntityDescription entityForName:@"Category" inManagedObjectContext:self.managedObjectContext];
    [request setEntity:entity];
    NSError *error;
    NSMutableArray *result = [[managedObjectContext executeFetchRequest:request error:&error] mutableCopy];
    [request release];
    NSLog(@"%i", [result count]);
    
    if ([result count] == 0) {
        NSManagedObject *newCategory = [NSEntityDescription insertNewObjectForEntityForName:@"Category" inManagedObjectContext:self.managedObjectContext];
        [newCategory setValue:text forKey:@"name"];
        [newCategory setValue:[NSDate date] forKey:@"updated"];
        NSLog(@"%@", [(Category *)newCategory encodeJSON]);
        [data insertObject:newCategory atIndex:1];
        [[self tableView] insertRowsAtIndexPaths:[NSArray arrayWithObject:[NSIndexPath indexPathForRow:1 inSection:0]] withRowAnimation:UITableViewRowAnimationLeft];
        [self.managedObjectContext save:nil];
        [(SyncManager *)[SyncManager sharedSyncManager] registerSyncTaskType:SyncTaskCreate forManagedObject:newCategory];
    }
    
    [result release];
}

#pragma mark - Helper functions

- (NSInteger)indexForString:(NSString *)aString inArray:(NSArray *)anArray
{
    NSInteger index = [anArray count];
    
    NSInteger i = 1;
    while (i < [anArray count] && index == [anArray count]) {
        if ([aString caseInsensitiveCompare:[anArray objectAtIndex:i]] == NSOrderedAscending) {
            index = i;
        }
        
        i++;
    }
    
    return index;
}

@end
