//
//  SyncManager.h
//  Corre
//
//  Created by Pedro on 03/05/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>
#import "CorreAppDelegate.h"
#import "ConflictsTableViewController.h"
#import "SyncManagerProtocol.h"
#import "SyncTask.h"

//#define kWebAppURL @"http://192.168.0.194:8000/core/api"
#define kWebAppURL @"http://correwebapp.appspot.com/core/api"

enum SyncTaskTypes {
    SyncTaskCreate = 0,
    SyncTaskModify = 1,
    SyncTaskDelete = 2
};
typedef NSUInteger SyncTaskTypes;

@interface SyncManager : NSObject {
    id<SyncManagerProtocol> delegate;
    NSManagedObjectContext *managedObjectContext;
    NSPersistentStoreCoordinator *persistentStoreCoordinator;
    NSMutableData *receivedData;
}

@property (nonatomic, retain) id<SyncManagerProtocol> delegate;
@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;
@property (nonatomic, retain) NSPersistentStoreCoordinator *persistentStoreCoordinator;
@property (nonatomic, retain) NSMutableData *receivedData;

+ (SyncManager *)sharedSyncManager;

// Registre de les dades a sincronitzar
- (void)registerSyncTaskType:(SyncTaskTypes)syncTaskType forManagedObject:(NSManagedObject *)managedObject;

// Prepara la representació JSON a enviar
- (NSString *)dataToSendJSON;

- (void)syncWithDelegate:(id<SyncManagerProtocol>)aDelegate;
- (void)syncRequest;
- (void)syncResponse:(NSDictionary *)result;
- (void)clearAllSyncTasks;
- (void)createAllNewSyncTasks;

@end
