//
//  Track.h
//  Corre
//
//  Created by Pedro Nofuentes Azcárate on 03/05/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>
#import "JSON/JSON.h"
#import "CorreAppDelegate.h"

@class Category, Place, Placemark, SimilarTracks;

@interface Track : NSManagedObject {
@private
}
@property (nonatomic, retain) NSNumber * maxAltitude;
@property (nonatomic, retain) NSNumber * maxSpeed;
@property (nonatomic, retain) NSDate * updated;
@property (nonatomic, retain) NSString * note;
@property (nonatomic, retain) NSNumber * ppm;
@property (nonatomic, retain) NSNumber * time;
@property (nonatomic, retain) NSNumber * distance;
@property (nonatomic, retain) NSDate * date;
@property (nonatomic, retain) NSString * dataKML;
@property (nonatomic, retain) NSString * name;
@property (nonatomic, retain) NSNumber * minAltitude;
@property (nonatomic, retain) NSSet* placemarks;
@property (nonatomic, retain) Category * category;
@property (nonatomic, retain) SimilarTracks * similarTracks;
@property (nonatomic, retain) NSSet* places;

- (void)addPlacesObject:(Place *)value;
- (void)addPlacemarksObject:(Placemark *)value;

- (float)distanceInKm;
- (float)speedInKmH;
- (float)maxSpeedInKmH;
- (float)pace;
- (NSString *)paceString;
- (void)setUpdatedTimestamp;
- (NSString *)formatTime;

- (void)writeKMLData;

- (NSDictionary *)toDictionary;
- (NSString *)encodeJSON;

@end
